Index: Commands2.cpp
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/Commands2.cpp,v
retrieving revision 1.42
retrieving revision 1.119
diff -u -p -b -r1.42 -r1.119
--- Commands2.cpp	10 Jul 2004 14:14:45 -0000	1.42
+++ Commands2.cpp	23 Jan 2005 01:34:53 -0000	1.119
@@ -721,22 +720,21 @@ bool Commands::rmd(User *user, string di
   return(true);
 }
 
-bool Commands::dele(User *user, string file)
+bool Commands::dele(User *user, string file, unsigned int flag)
 {
   string message, new_file = parsedir(user, file);
 
   if(unlink(new_file.c_str()))
   {
     message = "550 ";
-    if(errno == (EPERM || EACCES))
-      message = "File access denied, not deleted.";
+    if(errno == EPERM || errno == EACCES)
+      message += "File access denied, not deleted.";
     else if(errno == EPERM)
-      message = "File \"" + new_file + "\" is a directory.";
-    else if(errno == (ENOENT || EISDIR))
-      message = "File not found.";
+      message += "File \"" + new_file + "\" is a directory.";
+    else if(errno == ENOENT || errno == EISDIR)
+      message += "File not found.";
     else
       message = "450 File not available.";
-    return(false);
   }
   else
     message = "250 'DELE' command successful.";
@@ -745,21 +743,20 @@ bool Commands::dele(User *user, string f
   return(true);
 }
 
-bool Commands::port(User *user, string argument)
+bool Commands::port(User *user, string argument, unsigned int flag)
 {
   string tmp_adress, message;
-  int port, command = argument[0];
-  argument.erase(0, 1);
+  int port;
 
   memset(&user->data_addr, 0, sizeof(user->data_addr));
 
-  if(is_set(user->settings, EPSV_ONLY))
-    message = "501 Only 'EPSV' may be user after the issuing of 'EPSV ALL'";
+  if(user->settings.test(EPSV_ONLY))
+    message = "501 Only 'EPSV' may be used after the issuing of 'EPSV ALL'";
 
   else if((config->get_user(user->user_name).only_passive))
     message = "501 Sorry, active data transfers are disabled for your account.";
       
-  else if(command == COM_PORT)
+  else if(util.is_set(flag, COM_PORT))
   {
     class StringTokenizer *token = new StringTokenizer(argument, ",", false);
   
@@ -777,10 +774,10 @@ bool Commands::port(User *user, string a
     }
     delete token;
   }
-  else if(command == COM_EPRT)
+  else if(util.is_set(flag, COM_EPRT))
   {
     char separator[1];
-    separator[0] = (char)argument[0];
+    separator[0] = static_cast<char>(argument[0]);
     class StringTokenizer *token = new StringTokenizer(argument, separator, false);
 
     if(token->countTokens() != 3 || argument[argument.size() - 1] != argument[0])
@@ -801,100 +798,92 @@ bool Commands::port(User *user, string a
 
   if(message.size() == 0)
   {
-    pthread_mutex_lock(&user->lock);
+    sem_wait(&user->user_lock);
     if((inet_aton(tmp_adress.c_str(), &user->data_addr.sin_addr)) == 0)
     {
       message = "501 Illegal '";
-      message += (command == COM_PORT ? "PORT" : "EPRT");
+      message += (util.is_set(flag, COM_PORT) ? "PORT" : "EPRT");
       message += "' command.";
     }
     else
     {
       user->data_addr.sin_port = port;
       user->data_addr.sin_family = AF_INET;
-      remove_bit(user->settings, PASSIVE);
+      user->settings.reset(PASSIVE);
       message += "200 '";
-      message += (command == COM_PORT ? "PORT" : "EPRT");
+      message += (util.is_set(flag, COM_PORT) ? "PORT" : "EPRT");
       message += "' command successful.";
     }
-    pthread_mutex_unlock(&user->lock);
+    sem_post(&user->user_lock);
   }
   
   ftp_send(user, message);
   return(true);
 }
 
-bool Commands::pasv(User *user, string argument)
+bool Commands::pasv(User *user, string argument, unsigned int flag)
 {
   string message;
-  struct sockaddr_in tmp_addr, tmp_addr2;
-  socklen_t len, len2;
-  unsigned int p;
-  int command = argument[0];
-
-  argument.erase(0, 1);
-
-  util.upper(argument);
-  if(argument == "ALL" && command == COM_EPSV)
-  {
-    pthread_mutex_lock(&user->lock);
-    set_bit(user->settings, EPSV_ONLY);
-    pthread_mutex_unlock(&user->lock);
+
+  if(util.is_set(flag, COM_EPSV) && argument.size() > 0)
+  {
+    transform(argument.begin(), argument.end(), argument.begin(), (int(*)(int))toupper);
+    if(argument == "ALL" && util.is_set(flag, COM_EPSV))
+    {
+      sem_wait(&user->user_lock);
+      user->settings.set(EPSV_ONLY);
+      sem_post(&user->user_lock);
     message = "200 Now only accepting 'EPSV'";
   }
   else
+      message = "501 '" + argument + "' is not a valid argument to 'EPSV'.";
+  }
+  else
   {
-    len = sizeof(tmp_addr);
-    len2 = sizeof(tmp_addr2);
+    struct sockaddr_in tmp_addr, tmp_addr2;
+    socklen_t len = sizeof(tmp_addr);
 
-    memset(&user->data_addr, 0, sizeof(user->data_addr));
     memset(&tmp_addr, 0, len);
-    memset(&tmp_addr2, 0, len2);
+    memset(&tmp_addr2, 0, len);
 
-    pthread_mutex_lock(&user->lock);
+    sem_wait(&user->user_lock);
+    memset(&user->data_addr, 0, sizeof(user->data_addr));
     if(user->data_id)
       close(user->data_id);
 
     user->data_id = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
     user->data_addr.sin_family = AF_INET;
     user->data_addr.sin_addr.s_addr = INADDR_ANY;
-    bind(user->data_id, (struct sockaddr*)&user->data_addr, sizeof(user->data_addr));
+    bind(user->data_id, reinterpret_cast<struct sockaddr*>(&user->data_addr), sizeof(user->data_addr));
     listen(user->data_id, 1);
-    getsockname(user->data_id, (struct sockaddr*)&tmp_addr, &len);
-    getsockname(user->socket_id, (struct sockaddr*)&tmp_addr2, &len2);
-    set_bit(user->settings, PASSIVE);
-    pthread_mutex_unlock(&user->lock);
+    getsockname(user->data_id, reinterpret_cast<struct sockaddr*>(&tmp_addr), &len);
+    getsockname(user->socket_id, reinterpret_cast<struct sockaddr*>(&tmp_addr2), &len);
+    user->settings.set(PASSIVE);
+    sem_post(&user->user_lock);
 
-    p = ntohs(tmp_addr.sin_port);
+    unsigned int p = ntohs(tmp_addr.sin_port);
 
-    if(command == COM_PASV)
+    if(util.is_set(flag, COM_PASV))
     {
-      if(is_set(user->settings, EPSV_ONLY))
-        message = "501 Only 'EPSV' may be user after the issuing of 'EPSV ALL'";
+      if(user->settings.test(EPSV_ONLY))
+        message = "501 Only 'EPSV' may be used after the issuing of 'EPSV ALL'";
       
       else
       {
-        class StringTokenizer *token;
-        string ip_addr[5];
-
-        ip_addr[0] = inet_ntoa(tmp_addr2.sin_addr);
-        token = new StringTokenizer(ip_addr[0], ".", false);
-        ip_addr[1] = token->nextToken();
-        ip_addr[2] = token->nextToken();
-        ip_addr[3] = token->nextToken();
-        ip_addr[4] = token->nextToken();
-        delete token;
+        class StringTokenizer *token = new StringTokenizer(inet_ntoa(tmp_addr2.sin_addr), ".", false);
 
-        message = "227 Entering Passive Mode ("
-          + ip_addr[1] + ","
-          + ip_addr[2] + ","
-          + ip_addr[3] + ","
-          + ip_addr[4] + ","
-          + util.itos((p >> 8) & 255) + ","
+        message = "227 Entering Passive Mode (";
+        message += token->nextToken() + ",";
+        message += token->nextToken() + ",";
+        message += token->nextToken() + ",";
+        message += token->nextToken() + ",";
+        message += util.itos((p >> 8) & 255) + ","
           + util.itos(p & 255) + ").";
+
+        delete token;
       }
     }
-    else if(command == COM_EPSV)
+    else if(util.is_set(flag, COM_EPSV))
     {
       if(argument.size() > 0)
         if(argument != util.itos(PROT_IPV4))
@@ -909,24 +898,20 @@ bool Commands::pasv(User *user, string a
 }
 
 // rnfr and rnto
-bool Commands::rname(User *user, string argument)
+bool Commands::rname(User *user, string argument, unsigned int flag)
 {
-  int command;
   string file_name, message;
 
-  command = argument[0];
-  argument.erase(0, 1);
-
   file_name = parsedir(user, argument);
 
-  if(command == COM_FROM)
+  if(util.is_set(flag, COM_FROM))
   {
-    pthread_mutex_lock(&user->lock);
+    sem_wait(&user->user_lock);
     user->temp_buf = file_name;
-    pthread_mutex_unlock(&user->lock);
+    sem_post(&user->user_lock);
     message = "350 Command OK, waiting for RNTO.";
   }
-  else if(command == COM_TO)
+  else if(util.is_set(flag, COM_TO))
   {
     if(user->temp_buf.size() == 0)
       message = "503 RNTO must come after RNFR.";
@@ -938,13 +923,14 @@ bool Commands::rname(User *user, string 
         message = "550 Access denied.";
       else
         message = "553 Rename failed.";
+      user->temp_buf.erase();
     }
   }
   ftp_send(user, message);
   return(true);
 }
  
-bool Commands::opts(User *user, string argument)
+bool Commands::opts(User *user, string argument, unsigned int flag)
 {
   string command, message;
   class StringTokenizer *st;
@@ -957,7 +943,7 @@ bool Commands::opts(User *user, string a
   }
   else
   {
-    util.upper(argument);
+    transform(argument.begin(), argument.end(), argument.begin(), (int(*)(int))toupper);
     st = new StringTokenizer(argument, " ", true);
     command = st->nextToken();
     argument = st->restTokens();
@@ -968,24 +954,24 @@ bool Commands::opts(User *user, string a
       string fact;
       st = new StringTokenizer(argument, ";", false);
 
-      pthread_mutex_lock(&user->lock);
+      sem_wait(&user->user_lock);
       while(st->hasMoreTokens())
       {
         fact = st->nextToken();
-        if(fact == "TYPE") toggle(user->mlst_facts, FACT_TYPE);
-        else if(fact == "SIZE") toggle(user->mlst_facts, FACT_SIZE);
-        else if(fact == "MODIFY") toggle(user->mlst_facts, FACT_MODIFY);
-        else if(fact == "UNIQUE") toggle(user->mlst_facts, FACT_UNIQUE);
-        else if(fact == "PERM") toggle(user->mlst_facts, FACT_PERM);
-        else if(fact == "UNIX.MODE") toggle(user->mlst_facts, FACT_U_MODE);
-        else if(fact == "UNIX.UID") toggle(user->mlst_facts, FACT_U_UID);
-        else if(fact == "UNIX.GID") toggle(user->mlst_facts, FACT_U_GID);
-        else if(fact == "UNIX.LINK") toggle(user->mlst_facts, FACT_U_LINK);
+        if(fact == "TYPE") user->settings.flip(FACT_TYPE);
+        else if(fact == "SIZE") user->settings.flip(FACT_SIZE);
+        else if(fact == "MODIFY") user->settings.flip(FACT_MODIFY);
+        else if(fact == "UNIQUE") user->settings.flip(FACT_UNIQUE);
+        else if(fact == "PERM") user->settings.flip(FACT_PERM);
+        else if(fact == "UNIX.MODE") user->settings.flip(FACT_U_MODE);
+        else if(fact == "UNIX.UID") user->settings.flip(FACT_U_UID);
+        else if(fact == "UNIX.GID") user->settings.flip(FACT_U_GID);
+        else if(fact == "UNIX.LINK") user->settings.flip(FACT_U_LINK);
       };
 
-      pthread_mutex_unlock(&user->lock);
+      sem_post(&user->user_lock);
 
-      message = "200 MLS§T string now showing: " + mlst_string(user);
+      message = "200 MLST string now showing: " + mlst_string(user);
       delete st;
     }
     else
@@ -1001,53 +987,42 @@ string Commands::mlst_string(User *user)
 {
   string message;
 
-  message += ("Type"); message += (is_set(user->mlst_facts, FACT_TYPE) ? "*;" : ";");
-  message += ("Size"); message += (is_set(user->mlst_facts, FACT_SIZE) ? "*;" : ";");
-  message += ("Modify"); message += (is_set(user->mlst_facts, FACT_MODIFY) ? "*;" : ";");
-  message += ("Unique"); message += (is_set(user->mlst_facts, FACT_UNIQUE) ? "*;" : ";");
-  message += ("Perm"); message += (is_set(user->mlst_facts, FACT_PERM) ? "*;" : ";");
-  message += ("Unix.mode"); message += (is_set(user->mlst_facts, FACT_U_MODE) ? "*;" : ";");
-  message += ("Unix.uid"); message += (is_set(user->mlst_facts, FACT_U_UID) ? "*;" : ";");
-  message += ("Unix.gid"); message += (is_set(user->mlst_facts, FACT_U_GID) ? "*;" : ";");
-  message += ("Unix.link"); message += (is_set(user->mlst_facts, FACT_U_LINK) ? "*;" : ";");
+  message += ("Type"); message += (user->settings.test(FACT_TYPE) ? "*;" : ";");
+  message += ("Size"); message += (user->settings.test(FACT_SIZE) ? "*;" : ";");
+  message += ("Modify"); message += (user->settings.test(FACT_MODIFY) ? "*;" : ";");
+  message += ("Unique"); message += (user->settings.test(FACT_UNIQUE) ? "*;" : ";");
+  message += ("Perm"); message += (user->settings.test(FACT_PERM) ? "*;" : ";");
+  message += ("Unix.mode"); message += (user->settings.test(FACT_U_MODE) ? "*;" : ";");
+  message += ("Unix.uid"); message += (user->settings.test(FACT_U_UID) ? "*;" : ";");
+  message += ("Unix.gid"); message += (user->settings.test(FACT_U_GID) ? "*;" : ";");
+  message += ("Unix.link"); message += (user->settings.test(FACT_U_LINK) ? "*;" : ";");
   return(message);
 }
 
 // functions for small left over commands (noop, pwd, etc...)
-bool Commands::sim1(User *user, string argument)
+bool Commands::sim1(User *user, string argument, unsigned int flag)
 {
-  int command;
   string message;
   
-  command = argument[0];
-  argument.erase(0, 1);
-  util.upper(argument);
+  transform(argument.begin(), argument.end(), argument.begin(), (int(*)(int))toupper);
   
-  if(command == COM_NOOP)
+  if(util.is_set(flag, COM_NOOP))
     message = "200 'NOOP': Command successful.";
 
-  else if(command == COM_PWD)
+  else if(util.is_set(flag, COM_PWD))
   {
     string dir = user->current_dir;
-    if(config->get_user(user->user_name).only_home)
+    if(user->root_dir.size() > 1)
       dir.erase(0, user->root_dir.size());
     if(dir == "")
       dir = "/";
     message = "257 \"" + dir + "\" is current directory.";
   }
     
-  else if(command == COM_SYST)
+  else if(util.is_set(flag, COM_SYST))
     message = "215 " + config->general.os + " Type: L8";
 
-  else if(command == COM_CDUP)
-  {
-    pthread_mutex_lock(&user->lock);
-    user->current_dir = parsedir(user, user->current_dir += "/..");
-    pthread_mutex_unlock(&user->lock);
-    message = "200 'CDUP' command successful.";
-  }
-
-  else if(command == COM_FEAT)
+  else if(util.is_set(flag, COM_FEAT))
   {
     message =  "211-Extensions supported:\r\n";
     message += " SIZE\r\n";
@@ -1065,27 +1040,27 @@ bool Commands::sim1(User *user, string a
     message += "211 End.";
   }
 
-  else if(command == COM_TYPE)
+  else if(util.is_set(flag, COM_TYPE))
   {
     if(argument == "A" || argument == "A N")
     {
       message = "200 Type set to " + argument + ".";
-      pthread_mutex_lock(&user->lock);
-      remove_bit(user->settings, BINARY);
-      pthread_mutex_unlock(&user->lock);
+      sem_wait(&user->user_lock);
+      user->settings.reset(BINARY);
+      sem_post(&user->user_lock);
     }
     else if(argument == "I" || argument == "L 8")
     {
       message = "200 Type set to " + argument + ".";
-      pthread_mutex_lock(&user->lock);
-      set_bit(user->settings, BINARY);
-      pthread_mutex_unlock(&user->lock);
+      sem_wait(&user->user_lock);
+      user->settings.reset(BINARY);
+      sem_post(&user->user_lock);
     }
     else
       message = "504 'TYPE " + argument + "' not understood.";
   }
 
-  else if(command == COM_MODE)
+  else if(util.is_set(flag, COM_MODE))
   {
     if(argument == "S")
     {
@@ -1095,7 +1070,7 @@ bool Commands::sim1(User *user, string a
       message = "504 'MODE " + argument + "' not understood.";
   }
 
-  else if(command == COM_STRU)
+  else if(util.is_set(flag, COM_STRU))
   {
     if(argument == "F")
       message = "200 Structure set to F.";
@@ -1103,14 +1078,14 @@ bool Commands::sim1(User *user, string a
       message = "504 'STRU " + argument + "' not understood.";
   }
 #ifdef USE_TLS
-  else if(command == COM_PBSZ)
+  else if(util.is_set(flag, COM_PBSZ))
   {
-    if(is_set(user->settings, TLS_ENABLED))
+    if(user->settings.test(TLS_ENABLED))
     {
       if(argument == "0")
       {
         message = "200 PBSZ set for stream transfer.";
-        set_bit(user->settings, TLS_PBSZ);
+        user->settings.set(TLS_PBSZ);
       }
       else
         message = "501 PBSZ has to be set to 0 for use with TLS.";
@@ -1119,20 +1094,20 @@ bool Commands::sim1(User *user, string a
       message = "503 AUTH must be issued and negotiated before PBSZ can be used.";
   }
 
-  else if(command == COM_PROT)
+  else if(util.is_set(flag, COM_PROT))
   {
-    if(!is_set(user->settings, TLS_ENABLED) || !is_set(user->settings, TLS_PBSZ))
+    if(!user->settings.test(TLS_ENABLED) || !user->settings.test(TLS_PBSZ))
       message = "503 AUTH and PBSZ has to be issued and negotiated before PROT.";
     else
       switch(argument[0])
       {
         case 'C':
           message = "200 Data connection set to CLEAR level.";
-          remove_bit(user->settings, TLS_PROT_D);
+          user->settings.reset(TLS_PROT_D);
           break;
         case 'P':
           message = "200 Data connection set to PRIVATE level.";
-          set_bit(user->settings, TLS_PROT_D);
+          user->settings.set(TLS_PROT_D);
           break;
         case 'S':
         case 'E':
@@ -1142,16 +1117,35 @@ bool Commands::sim1(User *user, string a
           message = "504 Protection level '" + argument + "' not understood.";
       }
   }
-  else if(command == COM_CCC) // Clear Command Channel
+  else if(util.is_set(flag, COM_CCC)) // Clear Command Channel
   {
-    if(!is_set(user->settings, TLS_ENABLED))
+    if(!user->settings.test(TLS_ENABLED))
       message = "533 CCC can only be issued on a protected control connection.";
     else // code for disallowing CCC should be above, containing a 534
     {
       ftp_send(user, "200 Disabling TLS, control connection is now CLEAR.");
       gnutls_bye(user->ctrl_session, GNUTLS_SHUT_RDWR);
-      remove_bit(user->settings, TLS_ENABLED);
+      user->settings.reset(TLS_ENABLED);
+    }
     }
+  else if(util.is_set(flag, COM_CONF | COM_MIC | COM_ENC))
+  {
+    // note, if we implement som other security messure than TLS we might
+    // need these commands, for now they reside here and only return
+    // a 503 or 537.
+    string command;
+    if(util.is_set(flag, COM_CONF))
+      command = "CONF";
+    else if(util.is_set(flag, COM_MIC))
+      command += "MIC";
+    else
+      command += "ENC";
+
+    if(!user->settings.test(TLS_ENABLED))
+      message = "503 Command " + command
+        + " can not be issued before a valid security exchange.";
+    else
+      message = "537 Command " + command + " not used in TLS mode.";
   }
 #endif // USE_TLS
 
@@ -1160,25 +1154,21 @@ bool Commands::sim1(User *user, string a
   return(true);
 }
 
-bool Commands::sim2(User *user, string argument)
+bool Commands::sim2(User *user, string argument, unsigned int flag)
 {
-  int command;
   string file_name, message;
   struct stat stt;
 
-  command = argument[0];
-  argument.erase(0, 1);
-  
   file_name = parsedir(user, argument);
   if(!(stat(file_name.c_str(), &stt)))
   {
-    if(command == COM_SIZE)
+    if(util.is_set(flag, COM_SIZE))
       message = "213 " + util.itos(stt.st_size);
 
-    else if(command == COM_MDTM)
-      message = "213 " + mod_time(file_name, stt);
+    else if(util.is_set(flag, COM_MDTM))
+      message = "213 " + mod_time(stt);
 
-    else if(command == COM_MLST)
+    else if(util.is_set(flag, COM_MLST))
     {
       message  = "250-Listing " + argument + "\r\n";
       message += mlsx(user, file_name) + "\r\n";
@@ -1192,51 +1182,53 @@ bool Commands::sim2(User *user, string a
   return(true);
 }
 
-string Commands::mod_time(string file_name, struct stat stt)
+string Commands::mod_time(struct stat stt)
 {
-  char *date = new char[100];
-  struct tm *m;
-  string message;
+  char date[16] = {0};
+  struct tm m;
   
-  m = gmtime(&(stt.st_mtime));
-  snprintf(date, 95, "%u%02u%02u%02u%02u%02u", m->tm_year + 1900,m->tm_mon + 1, m->tm_mday, m->tm_hour, m->tm_min, m->tm_sec);
-  message = date;
-  delete[] date;
+  gmtime_r(&(stt.st_mtime), &m);
+  strftime(date, 15, "%Y%m%d%H%M%S", &m);
+  string message = date;
   return(message);
 }
 
 #ifdef USE_TLS
 
-bool Commands::auth(User *user, string argument)
+bool Commands::auth(User *user, string argument, unsigned int flag)
 {
-  int ret;
-  string message;
-  
-  util.upper(argument);
+  transform(argument.begin(), argument.end(), argument.begin(), (int(*)(int))toupper);
   
-  if(argument == "TLS" || argument == "TLS-C")
+  if(argument == "TLS" || argument == "TLS-C" || argument == "SSL")
   {
-    pthread_mutex_lock(&user->lock);
-    user->ctrl_session = Commands::init_tls();
-    set_bit(user->settings, TLS_INITED);
+    if(config->get_user(user->user_name).encryption == DENY)
+    {
+      ftp_send(user, "421 Sorry, you are not allowed to use encryption, disconnecting.");
+      sem_wait(&user->user_lock);
+      user->logged_in = LOGGED_OUT;
+      sem_post(&user->user_lock);
+    }
+    sem_wait(&user->user_lock);
+    Commands::init_tls(user->ctrl_session);
+    user->settings.set(TLS_INITED);
 
-    gnutls_transport_set_ptr(user->ctrl_session, (gnutls_transport_ptr)user->socket_id);
-    pthread_mutex_unlock(&user->lock);
+    gnutls_transport_set_ptr(user->ctrl_session, reinterpret_cast<gnutls_transport_ptr>(user->socket_id));
+    sem_post(&user->user_lock);
     ftp_send(user, "234 Now starting encryption using TLS.");
-    pthread_mutex_lock(&user->lock);
-    ret = gnutls_handshake(user->ctrl_session);
+    sem_wait(&user->user_lock);
 
-    if(ret < 0) // we failed =(
-    {
+    if(gnutls_handshake(user->ctrl_session) < 0)
+    { // failure =(
       user->logged_in = LOGGED_OUT;
-      pthread_mutex_unlock(&user->lock);
-      cout << gnutls_strerror(ret);
+      sem_post(&user->user_lock);
       ftp_send(user, "421 Handshake failed. Disconnecting.");
     }
-    else // wee!
-    {
-      set_bit(user->settings, TLS_ENABLED);
-      pthread_mutex_unlock(&user->lock);
+    else
+    { // wee!
+      user->settings.set(TLS_ENABLED);
+      if(argument == "SSL")
+        user->settings.set(TLS_PROT_D);
+      sem_post(&user->user_lock);
     }
   }
   else
